%global build_options  --enable-m17n --enable-unicode --enable-nls --with-editor=/bin/vi --with-mailer="gnome-open mailto:%s" --with-browser=gnome-open --with-charset=UTF-8 --with-gc --with-termlib=ncurses --enable-nntp --enable-gopher --enable-image=x11,fb --with-imagelib=gtk2 --enable-keymap=w3m

%global gitdate 20230121

%{?perl_default_filter}
%global __requires_exclude perl\\(w3mhelp-

Name:     w3m
Version:  0.5.3
Release:  2.git%{gitdate}%{?dist}
License:  MIT and UCD
URL:      http://w3m.sourceforge.net/
BuildRequires:  ncurses-devel
BuildRequires:  openssl-devel
BuildRequires:  perl-generators
BuildRequires:  pkgconfig
BuildRequires:  gettext-devel
%ifnarch s390 s390x
BuildRequires:  gpm-devel
%endif
BuildRequires:  gc-devel
BuildRequires:  nkf
BuildRequires:  lynx
BuildRequires:  gcc-c++
BuildRequires:  make

Requires: perl(NKF)

Source0: https://github.com/tats/%{name}/archive/v%{version}+git%{gitdate}/%{name}-%{version}+git%{gitdate}.tar.gz
Source1: w3mconfig

Patch0001: 0001-Fix-OOB-access-due-to-multiple-backspaces.patch

Summary:  Pager with Web browsing abilities
Provides: webclient
Provides: text-www-browser

%description
The w3m program is a pager (or text file viewer) that can also be used
as a text-mode Web browser. W3m features include the following: when
reading an HTML document, you can follow links and view images using
an external image viewer; its internet message mode determines the
type of document from the header; if the Content-Type field of the
document is text/html, the document is displayed as an HTML document;
you can change a URL description like 'http://hogege.net' in plain
text into a link to that URL.
If you want to display the inline images on w3m, you need to install
w3m-img package as well.

%package img
Summary: Helper program to display the inline images for w3m
BuildRequires:  gtk2-devel
BuildRequires:  gdk-pixbuf2-xlib-devel
Requires: ImageMagick
Requires: %{name} = %{version}-%{release}

%description img
w3m-img package provides a helper program for w3m to display the inline
images on the terminal emulator in X Window System environments and the
linux framebuffer.

%prep
%autosetup -n %{name}-%{version}-git%{gitdate} -p1

%build
%configure %{build_options}
%make_build

%install
%make_install

install -D -p -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/w3m/config

rm -f doc*/w3m.1

%find_lang w3m

%files -f w3m.lang
%doc doc NEWS README ChangeLog
%lang(ja) %doc doc-jp
%lang(de) %doc doc-de
%{_datadir}/w3m/
%config(noreplace) %{_sysconfdir}/w3m/
%{_bindir}/w3m*
%lang(ja) %{_mandir}/ja/man1/w3m.1*
%lang(de) %{_mandir}/de/man1/w3m.1*
%lang(de) %{_mandir}/de/man1/w3mman.1*
%{_mandir}/man1/w3m.1*
%{_mandir}/man1/w3mman.1*
%{_libexecdir}/w3m/
%exclude %{_libexecdir}/w3m/w3mimgdisplay

%files img
%{_libexecdir}/w3m/w3mimgdisplay

%changelog
* Fri Feb 21 2025 Doris Chao <doriscchao@tencent.com> - 0.5.3-2.git20230121
- [Type] security
- [DESC] Add patch to fix CVEs,including CVE-2022-38223, CVE-2023-38253,
- CVE-2023-38252 and CVE-2023-4255.

* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.5.3-1
- initial build
